/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.services.cservices.testcases.scu;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;

import java.io.IOException;


import cdac.medinfo.sdk.dcm30_04.baselibs.DataSet;
import cdac.medinfo.sdk.dcm30_04.baselibs.ImplicitDE;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.enums.EnumLoggingLevel;
import cdac.medinfo.sdk.dcm30_04.enums.EnumPDUType;

import cdac.medinfo.sdk.dcm30_04.services.association.AReleaseRQorRP;
import cdac.medinfo.sdk.dcm30_04.services.association.AssociateRQ;
import cdac.medinfo.sdk.dcm30_04.services.association.DefaultAssociation;
import cdac.medinfo.sdk.dcm30_04.services.cfind.commons.CFindRQ;
import cdac.medinfo.sdk.dcm30_04.services.cfind.commons.CFindRSP;
import cdac.medinfo.sdk.dcm30_04.services.cfind.scu.CFindSCU;
import cdac.medinfo.sdk.dcm30_04.services.dicomnetcommons.EnumServiceType;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.DicomMessage;
import cdac.medinfo.sdk.dcm30_04.services.dimsecommons.IAsyncReceiver;
import cdac.medinfo.sdk.dcm30_04.services.scu.commons.SCUSession;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.ISingleCollection;
import cdac.medinfo.sdk.dcm30_04.utils.SingleCollection;


/**
 *  * This class is implemented to test the C-Find SCU in Asynchronous Mode.
 * In Asynchronous Mode SCU sends multiple service request to SCP without waiting for the Response.
 * To implement C-Find SCU in Asynchronous mode user needs to implement interface IAsyncReceiver and should give 
 * implementation of onResponseReceive() and getNoOfRemainingResponses() method.
 * The IAsyncReceiver should be added  to SCU session to receive the response. Whenever a response 
 * is received by SCU Session, call back is made on onResponseReceive() method of the test code.
 * 
 * In order to run the following class , please refer to this link($Link) to create the environment.
 * To implement an SCU of a particular we need to do the following things:
 * Create the SCUSession object which maintains the current session of the SCU. Its "start" method accepts
 * the SCP's IP Address and Port and tries to establish a connection with the SCP. 
 * 
 *  Next step is to establish association .Some ways to create an Association Request: 
 * 1)Use Default Association class to Load the association for requested service. User can load the association 
 * by specifying the Service Type in loadAssociation method of Default association. For e.g. here EnumServiceType.CFind
 * should be specified to load Association for C-Find Services. The association request for C-Find
 * is made according to  jars in the class path.
 * 2) Manually create object of AssociationRQ class and set all presentation contexts collection on it. 
 * More details provided in the API DOCS of AssociationRQ class.
 * After successful association is established the SCUSession stores the status of the Association with it.  
 * 
 * After successful association is established the SCUSession stores the status of the Association with it.
 * Create CFindSCU object to send the C-Find Request to the respective SCP. In Async Mode all the requests
 * are send using "sendMessage" method of C-Find SCU.All C-Find requests are sent without waiting for the response to receive.As the request are processed at the SCP
 * the response is received by the SCU. Presently the test code itself is IAsyncReceiver . 
 * So when the C-Store RSP is received then onResponseReceive method is called.
 * The response can be added in the collection there.
 * 
 * After this, create a A-Release-RQ in order to request for association release 
 * and send it using the SCUSession object. This again is a blocking call and the SCUSession waits until a A-Release-RP is received.
 * 
 * When CFind request is send to the server with key attribute to be searched in the data set
 * then for the matches find (for key attribute at SCP side) it sends the Pending response which contains 
 * matched data set. Then success response is sent by SCP.
 * At the end of an operation calling "close" on SCUSession would disconnect the connection made with the 
 * SCP and release all the acquired resources.
 * Instead of closing the session after a C-Find operation is complete,we can create another association
 * and send more requests. 
 */
public class CFind_SCU_Async  implements IAsyncReceiver
{
	//Collection containing C-Find Response.
	ISingleCollection<DicomMessage> cFindRespCollection = new SingleCollection<DicomMessage>();

	public static void main(String[] args) throws IOException
	{
		DicomConfig objDicomConfig = DicomConfig.createInstance();

		//enable logging,specify the path of the directory where log files are created.
		//User can specify any directory in place of 'c:\DCM_Logs'.
		//If no directory is defined by user to create logs then it is created in User Temp DIR.
		objDicomConfig.enableLogging(EnumLoggingLevel.INFO, "C:\\DCM_Logs");

		CFind_SCU_Async objTestCFindSCU = new CFind_SCU_Async();

		objTestCFindSCU.start();
	}

	/**
	 * This function performs the C-Find operation.
	 */
	public void start()
	{

		//create SCU session.
		SCUSession objSession = null;

		try
		{
			//Create SCUSession object
			objSession = new SCUSession();
			
			/*
			 * Setting time out as 5000 milli second. It will wait 5000 mili seconds for read and write operation.
			 * If in the time specified (5000 ms) read or write operation is not performed then 
			 * session is time out.
			 */ 
			//objSession.setTimeOut(5000);
			
			objSession.addAsyncReceiver(this);

			/*
			 * Initializes the service types and populates the default association
			 */
			EnumServiceType[] arrenumServiceType = new EnumServiceType[1];
			arrenumServiceType[0] = EnumServiceType.CFIND_DEFAULT;
			DefaultAssociation objDefaultAssociation = new DefaultAssociation("SDK");
			objDefaultAssociation.loadAssociation(arrenumServiceType);

			//Create Association RQ
			AssociateRQ objAssociateRQ = objDefaultAssociation.getAssociationRQ("SDK");

			/*
			 * Change Assocaition request for Async Operation.
			 * Set Maximum Number of operation invoked and performed in RQUserInfo.
			 * If the value of Max mumber of Operation performed and invoked is zero 
			 * then it means it is unbounded.
			 */
			objAssociateRQ.getRQUserInfo().setMaxNumOpsInvoked((short)0);
			objAssociateRQ.getRQUserInfo().setMaxNumOpsPerformed((short)0);

			//Add test code as Async Receiver to get the response.  
			objSession.addAsyncReceiver(this);

			//Start the Session
			objSession.start("192.168.8.94", 9000);

			/*
			 * Create C-Find SCU.
			 */
			CFindSCU objCFindSCU = new CFindSCU(objSession);

			if(objSession.sendAssociationMessage(objAssociateRQ))
			{	
				//When association is successfully established the "objSession.sendAssociationMessage()"
				//method returns true.
				System.out.println("Association established");

				CFindRQ objCFindRQ = null;

				for(int i=0; i<11;i++)
				{
					//Get the C-Find Data Set.
					IDataSet objIDataSet = getDataSet();

					//Create Default Find RQ by giving the parsed DataSet. This method uses
					// default values for the attributes in the request. These attributes can be
					//modified once the request object is created, before sending.
					objCFindRQ = CFindRQ.getDefaultRQ(DicomConstants.DCM_STUDY_ROOT_QUERY_RETRIEVE_INFORMATION_MODEL_FIND, objIDataSet);

					if(objCFindSCU.sendMessage(objCFindRQ))
					{
						System.out.println("C-Find Request Sent");
					}
					else
					{
						System.out.println("C-Find operation failed");
					}
				}

				//On Completion of C-Find operation send ARelease request.
				AReleaseRQorRP objAReleaseRQorRP = new AReleaseRQorRP(EnumPDUType.RELEASE_RQ);
				if(objSession.sendAssociationMessage(objAReleaseRQorRP))
				{
					System.out.println("Association is released");
					objSession.close();
				}
			}
			else
			{
				System.out.println("Associaiton cannot be established");
				objSession.close();
			}
		}
		catch(Exception e)
		{
			objSession.close();
		}
	}

	/**
	 * This method creates Find Data Set. It Contains the Key value according to which
	 * other attributes are to be received.
	 * @return IDataSet Data Set to be set in C-Find Request.
	 */
	public IDataSet getDataSet()
	{
		IDataSet objIDataSet = new DataSet();
		IDictionaryReader objIDictionaryReader = objIDataSet.getDictionaryReader();
		IDataElement objIDataElement = new ImplicitDE(0x0008,0x0020,"19930325",objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0020,0x1208,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0008,0x0030,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0008,0x0050,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0008,0x0052,"STUDY",objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0020,0x000d,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0020,0x0010,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		objIDataElement = new ImplicitDE(0x0020,0x1206,null,objIDictionaryReader);
		objIDataSet.addDataElement(objIDataElement);
		return objIDataSet;
	}

	/**
	 * Gets the no of remaining responses.
	 * @return int
	 */
	public int getNoOfRemainingResponses() 
	{
		return cFindRespCollection.size();
	}

	int count = 1;

	/**
	 * This method is call backed when Response is received.
	 * @param response  Response received.
	 */
	public void onResponseReceive(DicomMessage response) throws IOException
	{
		System.out.println("------------------ CFind response added in collection.-----------------------" + count++);
		cFindRespCollection.add(response);
		CFindRSP objCFindRSP = new CFindRSP(response);
		System.out.println("C-Find Response Status  :" + objCFindRSP.getStatus());
	}
}
